// pan and sound_volume still don't work (music_volume does)

#include "Common/StdAfx.h"
#include "Audio.h"
#include "Compress.h"
#include "Graphics.h"
#include "Kernel.h"
#include "../Strings.h"


CAudio Audio;

CAudio::CAudio (void) {
    memset (this, 0, sizeof (CAudio));
    sound       = 1;
    directsound = 1;
    music       = 1;
    directmusic = 1;
    pan         = 0;
    volume      = 5;
}

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;

void CAudio::Init      (unsigned, unsigned, unsigned, unsigned d) {
    unsigned i; for (i=0; i<=d; i++) theApp.HandleProgBar ();
}
void CAudio::Music     (unsigned, unsigned) { }
void CAudio::Destroy   (void)     { }
void CAudio::Suspend   (void)     { }
void CAudio::Update    (void)     { }
void CAudio::Sound     (unsigned) { }
void CAudio::SetPan    (unsigned) { }
void CAudio::SetVolume (unsigned) { }
miDSound::miDSound     (void)     { }
miDSound::~miDSound    (void)     { }

#else

void CAudio::Music (unsigned s1, unsigned s2) {
    if (s1 >= maxmusic) s1 = maxmusic - 1;
    if (s2 >= maxmusic) s2 = maxmusic - 1;
    if (s2 > s1) {
        rnd_music = s1;
        rnd_last  = s2;
        if ((curmusic < s1 || curmusic > s2) && curmusic != 0) newmusic = 0;
    } else {
        newmusic  = s1;
        rnd_music = 0;
        rnd_last  = 0;
    }
}

#ifndef LINUX

void CAudio::Init (unsigned woff, unsigned moff, unsigned wmax, unsigned mmax) {
    unsigned     i,
                 j;
    DSBUFFERDESC dsbdDesc;
    WAVEFORMATEX wfx;
    BOOL         fAuto = TRUE;

    offset_wave = woff;
    offset_midi = moff;
    maxsound    = wmax;
    maxmusic    = mmax;
    if (maxsound > MAXWAVE_GUESS) maxsound = MAXWAVE_GUESS;
    if (maxmusic > MAXMIDI_GUESS) maxmusic = MAXMIDI_GUESS;

    for (i=0; theApp.HomeDir[i]; i++) TempFile[i] = theApp.HomeDir[i];
    TempFile[i] = 0;
    if (TempFile[i] == SLASHCHAR) i--;
    for (j=0; StrTable[Str_TempFile][j]; j++, i++) {
        TempFile[i] = StrTable[Str_TempFile][j];
        if (TempFile[i] == '\\') TempFile[i] = SLASHCHAR;
    }
    TempFile[i] = 0;
    for (i=0; i<5; i++) MidiStr[i] = StrTable[Str_MidiOpen][i];
    for (i=0; TempFile[i]; i++) MidiStr[i+5] = TempFile[i]; i += 5;
    for (j=0; StrTable[Str_MidiOpn1][j]; i++, j++) MidiStr[i] = StrTable[Str_MidiOpn1][j];

    theApp.HandleProgBar ();
    if (music && directmusic) {
        do {
            directmusic = false;
            if (FAILED (CoInitialize (NULL))) break;
            if (FAILED (CoCreateInstance (
                        CLSID_DirectMusicPerformance,
                        NULL,
                        CLSCTX_INPROC,
                        IID_IDirectMusicPerformance2,
                        (void**) &pPerf
                ))) { pPerf = NULL; break; }
            if (FAILED (pPerf->Init (NULL, NULL, Screen.GetSafeHwnd ()))) break;
            if (FAILED (pPerf->AddPort (NULL))) break;
            if (FAILED (CoCreateInstance (
                        CLSID_DirectMusicLoader,
                        NULL,
                        CLSCTX_INPROC, 
                        IID_IDirectMusicLoader,
                        (void**) &pLoader
                ))) { pLoader = NULL; break; }
            directmusic = true;
            i = 200;
            pPerf->SetGlobalParam (GUID_PerfAutoDownload, &fAuto, sizeof (fAuto));
            pPerf->SetGlobalParam (GUID_PerfMasterVolume, &i,     sizeof (i));
        } while (0);
        if (directmusic == false) {
            if (pPerf) {
                if (pMIDISeg) {
                    pMIDISeg->SetParam (GUID_Unload, (unsigned long) -1, 0, 0, (void*) pPerf);
                    pMIDISeg->Release  ();
                }
                pPerf->CloseDown ();
                pPerf->Release   ();
            }
            CoUninitialize ();
        } else for (i=0; i < maxmusic; i++) {
            theApp.HandleProgBar ();
            j = MediaRef[i + offset_midi];
            if (j == 0) continue;
            if (j & ALTLIB) {
                if (theApp.AltLib == NULL) continue;
                fseek (theApp.AltLib, j ^ ALTLIB, SEEK_SET);
                MidiBuffer[i] = (unsigned char*) pack.ExpandToRam (theApp.AltLib);
            } else {
                fseek (theApp.MediaLib, j, SEEK_SET);
                MidiBuffer[i] = (unsigned char*) pack.ExpandToRam (theApp.MediaLib);
            }
            if (MidiBuffer[i] == NULL) continue;
            memset (&(ObjDesc[i]), 0, sizeof (DMUS_OBJECTDESC));
            ObjDesc[i].guidClass   = CLSID_DirectMusicSegment;
            ObjDesc[i].dwSize      = sizeof (DMUS_OBJECTDESC);
            ObjDesc[i].dwValidData = DMUS_OBJ_CLASS | DMUS_OBJ_MEMORY | DMUS_OBJ_LOADED;
            ObjDesc[i].pbMemData   = MidiBuffer[i];
            ObjDesc[i].llMemLength = pack.textsize;
        }
    }
    if (directmusic == false) {
        for (i=0; i<maxmusic; i++) theApp.HandleProgBar ();
        if (music) {
            fseek (theApp.MediaLib, MediaRef[offset_midi], SEEK_SET);
            if (pack.ReadBuffer () || ferror (theApp.MediaLib) || MediaRef[offset_midi] == 0) {
                music = false;
            } else if (pack.WriteBufferPure (TempFile)) {
                music = false;
            } else {
                mciSendString (MidiStr, NULL, 0, 0);
                mciSendString (StrTable[Str_MidiPlay], NULL, 0, 0);
            }
        }
    }

    theApp.HandleProgBar ();
    if (sound && directsound) do {
        directsound = false;
        lpDirectSound = NULL;
        if (FAILED (DirectSoundCreate (NULL, &lpDirectSound, NULL))) break;
        if (FAILED (lpDirectSound->SetCooperativeLevel (Screen.GetSafeHwnd (), DSSCL_PRIORITY))) break;
        memset (&dsbdDesc, 0, sizeof (DSBUFFERDESC));
        dsbdDesc.dwSize  = sizeof (DSBUFFERDESC);
        dsbdDesc.dwFlags = DSBCAPS_PRIMARYBUFFER | DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLPAN;
        if (FAILED (lpDirectSound->CreateSoundBuffer (&dsbdDesc, &basesound, NULL))) {
            theApp.DebugMessage ("Volume controls unavailable.", true);
            dsbdDesc.dwFlags = DSBCAPS_PRIMARYBUFFER;
            if (FAILED (lpDirectSound->CreateSoundBuffer (&dsbdDesc, &basesound, NULL))) break;
        }
        memset (&wfx, 0, sizeof (WAVEFORMATEX));
        wfx.wFormatTag      = WAVE_FORMAT_PCM; 
        wfx.nChannels       = 2; 
        wfx.nSamplesPerSec  = 22050; 
        wfx.wBitsPerSample  = 16; 
        wfx.nBlockAlign     = wfx.wBitsPerSample / 8 * wfx.nChannels;
        wfx.nAvgBytesPerSec = wfx.nSamplesPerSec * wfx.nBlockAlign;
        if (FAILED (basesound->SetFormat(&wfx))) break;
        directsound = true;
    } while (0);
    if (directsound == false && sound) {
        sndPlaySound (NULL, SND_ASYNC | SND_NOWAIT);
    }
    SetVolume (volume);
}

void CAudio::Destroy (void) {
    unsigned i;
    if (sound) {
        if (directsound) {
            for (i=0; i<maxsound; i++) {
                if (soundfx[i].IsPlaying ()) i = 0;
            }
            for (i=0; i<maxsound; i++) {
                soundfx[i].~miDSound ();
                if (soundbuf[i]) {
                    delete [] soundbuf[i];
                    soundbuf[i] = NULL;
                }
            }
            if (basesound) {
                basesound->Release ();
                basesound = NULL;
            }
            if (lpDirectSound) {
                /* crashes
                lpDirectSound->Release ();
                lpDirectSound = NULL;
                */
            }
        } else {
            sndPlaySound (NULL, SND_ASYNC | SND_NOWAIT);
            for (i=0; i<maxsound; i++) if (soundbuf[i]) {
                delete [] soundbuf[i];
                soundbuf[i] = NULL;
            }
        }
    }
    if (music) {
        if (directmusic) {
            if (pPerf) {
                do pPerf->Stop (NULL, NULL, 0, 0);
                while (pPerf->IsPlaying (pMIDISeg, NULL) == S_OK);
                if (pMIDISeg) {
                    pMIDISeg->SetParam (GUID_Unload, (unsigned long) -1, 0, 0, (void*) pPerf);
                    pMIDISeg->Release  ();
                    pMIDISeg = NULL;
                }
                pPerf->CloseDown ();
                pPerf->Release   ();
                pPerf = NULL;
            }
            if (pLoader) {
                pLoader->Release ();
                pLoader = NULL;
            }
            CoUninitialize ();
            for (i=0; i<25; i++) {
                if (MidiBuffer[i]) {
                    delete [] MidiBuffer[i];
                    MidiBuffer[i] = NULL;
                }
            }
        } else {
            mciSendString (StrTable[Str_MidiStop], NULL, 0, 0);
        }
    }
    theApp.DeleteFile (TempFile);
}

void CAudio::Suspend (void) {
    unsigned i;
    if (music) {
        if (directmusic) {
            pPerf->Stop (NULL, NULL, 0, 0);
        } else {
            mciSendString (StrTable[Str_MidiStop], NULL, 0, 0);
        }
        curmusic = Mid_None;
    }
    if (sound) {
        if (directsound) {
            for (i=0; i<maxsound; i++) {
                soundfx[i].StopBuffer (false);
            }
        } else {
            sndPlaySound (NULL, SND_ASYNC | SND_NOWAIT);
        }
    }
}

void CAudio::Update (void) {
    unsigned        i;
    char            rval      [4];
    bool            isplaying;
    static int      delay     = 0;
    static unsigned starting  = 999;
    static unsigned lastmusic = 0;
    if (music && music_on) {
        if (curmusic != newmusic) {
            if (curmusic == Mid_None) curmusic = newmusic;
            else                      curmusic = Mid_None;
            isplaying = false;
            if (directmusic) {
                pPerf->Stop (NULL, NULL, 0, 0);
                i = pLoader->GetObject (&(ObjDesc[newmusic]), IID_IDirectMusicSegment2, (void**) &pMIDISeg);
                if (SUCCEEDED (i)) {
                    pMIDISeg->SetParam (GUID_StandardMIDIFile, (unsigned long) -1, 0, 0, (void*) pPerf);
                    pMIDISeg->SetParam (GUID_Download,         (unsigned long) -1, 0, 0, (void*) pPerf);
                    pMIDISeg->SetRepeats (0);
                }
            } else {
                mciSendString (StrTable[Str_MidiStop], NULL, 0, 0);
                i = MediaRef[curmusic + offset_midi];
                if (i != 0) {
                    if (i & ALTLIB) {
                        if (theApp.AltLib) {
                            fseek (theApp.AltLib, i ^ ALTLIB, SEEK_SET);
                            i = pack.ReadBuffer (theApp.AltLib);
                        }
                    } else {
                        fseek (theApp.MediaLib, i, SEEK_SET);
                        i = pack.ReadBuffer ();
                    }
                    if (i == 0) {
                        if (pack.WriteBufferPure (TempFile) == 0) {
                            mciSendString (MidiStr, NULL, 0, 0);
                        }
                    }
                }
            }
        } else {
            if (directmusic) {
                isplaying = (pPerf->IsPlaying (pMIDISeg, NULL) == S_OK);
            } else {
                mciSendString (StrTable[Str_MidiStat], rval, sizeof (rval), 0);
                isplaying = (rval[0] == 'p');
            }   
            if (isplaying == false && rnd_music) {
                if (delay) {
                    delay --;
                } else {
                    if (rnd_last - rnd_music < 3) lastmusic = 0;
                    while (newmusic == curmusic || newmusic == lastmusic) {
                        newmusic = random (rnd_last - rnd_music + 1) + rnd_music;
                    }
                    lastmusic = curmusic;
                    delay     = 12;
                    return;
                }
            }
        }
        if (isplaying == false) {
            if (curmusic == starting) return;
            starting = curmusic;
            if (directmusic) {
                i = pPerf->PlaySegment (pMIDISeg, 0, 0, NULL);
            } else {
                mciSendString (StrTable[Str_MidiPlay], NULL, 0, 0);
            }
        } else starting = 999;
    }
}

void CAudio::Sound (unsigned snum) {
    unsigned i;
    if (sound && sound_on) {
        if (snum >= maxsound) return;
        if (directsound) {
            if (soundbuf[snum] == NULL) {
                i = MediaRef[snum + offset_wave];
                if (i == 0) return;
                if (i & ALTLIB) {
                    if (theApp.AltLib == NULL) return;
                    fseek (theApp.AltLib, i ^ ALTLIB, SEEK_SET);
                    i = pack.ReadBuffer (theApp.AltLib);
                } else {
                    fseek (theApp.MediaLib, i, SEEK_SET);
                    i = pack.ReadBuffer ();
                }
                if (i) return;
                pack.WriteBufferPure        (TempFile);
                soundfx [snum].LoadWaveFile (TempFile);
                theApp.DeleteFile           (TempFile);
                soundbuf[snum] ++;
            }
            soundfx[snum].PlayBuffer (false);
        } else {
            if (soundbuf[snum] == NULL) {
                i = MediaRef[snum + offset_wave];
                if (i == 0) return;
                if (i & ALTLIB) {
                    if (theApp.AltLib == NULL) return;
                    fseek (theApp.AltLib, i, SEEK_SET);
                    soundbuf[snum] = pack.ExpandToRam (theApp.AltLib);
                } else {
                    fseek (theApp.MediaLib, i, SEEK_SET);
                    soundbuf[snum] = pack.ExpandToRam (theApp.MediaLib);
                }
                if (soundbuf[snum] == NULL) return;
            }
            sndPlaySound (soundbuf[snum], SND_ASYNC | SND_NODEFAULT | SND_MEMORY | SND_NOWAIT);
        }
    }
}

void CAudio::SetPan (unsigned dir) {
    switch (dir) {
        case Sound_Left:  pan = DSBPAN_LEFT;   break;
        case Sound_Right: pan = DSBPAN_RIGHT;  break;
        default:          pan = DSBPAN_CENTER; break;
    }
}

void CAudio::SetVolume (unsigned nvol) {
    int voldata [9] = { 5, 10, 20, 40, 80, 160, 320, 640, 1000 };
    if (nvol > 9) nvol = 9;
    volume = nvol;
    if (music_on && directmusic) {
        pPerf->SetGlobalParam (GUID_PerfMasterVolume, &voldata[nvol], sizeof (unsigned));
    }
    if (sound && directsound) {
        //basesound->SetVolume (DSBVOLUME_MIN + (((DSBVOLUME_MAX - DSBVOLUME_MIN) * (nvol + 1)) / 10));
    }
}

HRESULT ReadMMIO (HMMIO hmmioIn, MMCKINFO* pckInRIFF, WAVEFORMATEX** ppwfxInfo) {
    MMCKINFO        ckIn;
    PCMWAVEFORMAT   pcmWaveFormat;      
    *ppwfxInfo = NULL;

    if((0 != mmioDescend(hmmioIn, pckInRIFF, NULL, 0))){return E_FAIL;}
    if((pckInRIFF->ckid != FOURCC_RIFF) || (pckInRIFF->fccType != mmioFOURCC('W', 'A', 'V', 'E') ) ){return E_FAIL;}
    ckIn.ckid = mmioFOURCC('f', 'm', 't', ' ');
    if(0 != mmioDescend(hmmioIn, &ckIn, pckInRIFF, MMIO_FINDCHUNK)){return E_FAIL;}
    if(ckIn.cksize < (LONG)sizeof (PCMWAVEFORMAT)){return E_FAIL;}
    if(mmioRead(hmmioIn, (HPSTR) &pcmWaveFormat, sizeof (PCMWAVEFORMAT)) != sizeof (pcmWaveFormat)){return E_FAIL;}
    if( pcmWaveFormat.wf.wFormatTag == WAVE_FORMAT_PCM ){
        if(NULL == (*ppwfxInfo = new WAVEFORMATEX)){return E_FAIL;}
        memcpy( *ppwfxInfo, &pcmWaveFormat, sizeof (PCMWAVEFORMAT));
        (*ppwfxInfo)->cbSize = 0;
    }else{
        WORD cbExtraBytes = 0L;
        if(mmioRead(hmmioIn, (CHAR*)&cbExtraBytes, sizeof (WORD)) != sizeof (WORD)){return E_FAIL;}
        *ppwfxInfo = (WAVEFORMATEX*) new CHAR[ sizeof (WAVEFORMATEX) + cbExtraBytes ];
        if(NULL == *ppwfxInfo){return E_FAIL;}
        memcpy(*ppwfxInfo, &pcmWaveFormat, sizeof (PCMWAVEFORMAT));
        (*ppwfxInfo)->cbSize = cbExtraBytes;
        if(mmioRead(hmmioIn, (CHAR*)(((BYTE*)&((*ppwfxInfo)->cbSize))+sizeof (WORD)), cbExtraBytes ) != cbExtraBytes ){
            delete *ppwfxInfo;
            *ppwfxInfo = NULL;
            return E_FAIL;
        }
    }
    if(0 != mmioAscend( hmmioIn, &ckIn, 0)){
        delete *ppwfxInfo;
        *ppwfxInfo = NULL;
        return E_FAIL;
    }
    return S_OK;
}

HRESULT WaveOpenFile (CHAR* strFileName, HMMIO* phmmioIn, WAVEFORMATEX** ppwfxInfo, MMCKINFO* pckInRIFF) {
    HRESULT hr;
    HMMIO   hmmioIn = NULL;
    if(NULL == (hmmioIn = mmioOpen( strFileName, NULL, MMIO_ALLOCBUF|MMIO_READ))){return E_FAIL;}
    if(FAILED(hr = ReadMMIO(hmmioIn, pckInRIFF, ppwfxInfo))){
        mmioClose (hmmioIn, 0);
        return hr;
    }
    *phmmioIn = hmmioIn;
    return S_OK;
}

HRESULT WaveStartDataRead (HMMIO* phmmioIn, MMCKINFO* pckIn, MMCKINFO* pckInRIFF) {
    if( -1 == mmioSeek( *phmmioIn, pckInRIFF->dwDataOffset + sizeof (FOURCC), SEEK_SET )){return E_FAIL;}
    pckIn->ckid = mmioFOURCC('d', 'a', 't', 'a');
    if(0 != mmioDescend(*phmmioIn, pckIn, pckInRIFF, MMIO_FINDCHUNK)){return E_FAIL;}
    return S_OK;
}

HRESULT WaveReadFile (HMMIO hmmioIn, UINT cbRead, BYTE* pbDest, MMCKINFO* pckIn, UINT* cbActualRead) {
    MMIOINFO mmioinfoIn;

    *cbActualRead = 0;
    if(0 != mmioGetInfo(hmmioIn, &mmioinfoIn, 0)){return E_FAIL;}
                
    UINT cbDataIn = cbRead;
    if(cbDataIn > pckIn->cksize){cbDataIn = pckIn->cksize;}
    pckIn->cksize -= cbDataIn;
    for( DWORD cT = 0; cT < cbDataIn; cT++ ){
        if( mmioinfoIn.pchNext == mmioinfoIn.pchEndRead ){
            if(0 != mmioAdvance(hmmioIn, &mmioinfoIn, MMIO_READ)){return E_FAIL;}
            if(mmioinfoIn.pchNext == mmioinfoIn.pchEndRead){return E_FAIL;}
        }
        *((BYTE*)pbDest+cT) = *((BYTE*)mmioinfoIn.pchNext);
        mmioinfoIn.pchNext++;
    }
    if(0 != mmioSetInfo(hmmioIn, &mmioinfoIn, 0)){return E_FAIL;}
    *cbActualRead = cbDataIn;
    return S_OK;
}

miDSound::miDSound (void) {
    m_pwfx      = NULL;
    g_pDSBuffer = NULL;
    g_pDSNotify = NULL;
}

miDSound::~miDSound (void) {
    mmioClose (m_hmmioIn, 0);
    if (m_pwfx) {
        delete m_pwfx;
        m_pwfx = NULL;
    }
    if (g_pDSBuffer) {
        g_pDSBuffer->Release ();
        g_pDSBuffer = NULL;
    }
}

bool miDSound::LoadWaveFile (TCHAR* strFileName) {
    DSBUFFERDESC dsbd;
    memset (&dsbd, 0, sizeof (DSBUFFERDESC));
    if (g_pDSBuffer) {
        g_pDSBuffer->Release ();
        g_pDSBuffer = NULL;
    }
    if (m_pwfx) {
        delete m_pwfx;
        m_pwfx = NULL;
    }
    if (FAILED (WaveOpenFile (strFileName, &m_hmmioIn, &m_pwfx, &m_ckInRiff))) return FALSE;
    if (FAILED (WaveStartDataRead (&m_hmmioIn, &m_ckIn, &m_ckInRiff))) {
        mmioClose (m_hmmioIn, 0);
        return FALSE;
    }

    dsbd.dwSize        = sizeof (DSBUFFERDESC);
    dsbd.dwFlags       = DSBCAPS_STATIC | DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLPAN;
    dsbd.dwBufferBytes = m_ckIn.cksize;
    dsbd.lpwfxFormat   = m_pwfx;
    if (FAILED (Audio.lpDirectSound->CreateSoundBuffer (&dsbd, &g_pDSBuffer, NULL))) {
        dsbd.dwFlags = DSBCAPS_STATIC;
        if (FAILED (Audio.lpDirectSound->CreateSoundBuffer (&dsbd, &g_pDSBuffer, NULL))) {
            mmioClose (m_hmmioIn, 0);
            return FALSE;
        }
    }
    g_dwBufferBytes = dsbd.dwBufferBytes;
    if (FillBuffer ()) {
        mmioClose (m_hmmioIn, 0);
        return TRUE;
    }
    mmioClose (m_hmmioIn, 0);
    return FALSE;
}

bool miDSound::FillBuffer (void) {
    BYTE  *pbWavData;
    UINT  cbWavSize;
    DWORD dwLength,
          dwLength2;
    INT   nWaveFileSize = m_ckIn.cksize;
    VOID  *pbData       = NULL,
          *pbData2      = NULL;

    pbWavData = new BYTE [nWaveFileSize];
    if (pbWavData == NULL) return FALSE;

    if (FAILED (WaveReadFile(m_hmmioIn, nWaveFileSize, pbWavData, &m_ckIn, &cbWavSize))) return FALSE;
    WaveStartDataRead (&m_hmmioIn, &m_ckIn, &m_ckInRiff);
    if (FAILED (g_pDSBuffer->Lock(0, g_dwBufferBytes, &pbData, &dwLength, &pbData2, &dwLength2, 0L))) return FALSE;

    memcpy (pbData, pbWavData, g_dwBufferBytes);
    g_pDSBuffer->Unlock (pbData, g_dwBufferBytes, NULL, 0);
    pbData = NULL;
    if (pbWavData) {
        delete pbWavData;
        pbWavData = NULL;
    }
    return TRUE;
}

bool miDSound::IsPlaying (void) {
    DWORD dwStatus = 0;
    if (g_pDSBuffer == NULL) return FALSE;
    g_pDSBuffer->GetStatus (&dwStatus);
    return (dwStatus & DSBSTATUS_PLAYING);
}

bool miDSound::PlayBuffer (bool bLooped) {
    DWORD   dwStatus = 0,
            dwLooped = bLooped ? DSBPLAY_LOOPING : 0L;
    HRESULT hr;
    if (g_pDSBuffer == NULL) return FALSE;
    if (FAILED (g_pDSBuffer->GetStatus (&dwStatus))) return FALSE;

    if (dwStatus & DSBSTATUS_PLAYING) {
        g_pDSBuffer->SetCurrentPosition (0);
        //g_pDSBuffer->SetVolume (0);
        return TRUE;
    }

    if (dwStatus & DSBSTATUS_BUFFERLOST) {
        while (1) {
            hr = g_pDSBuffer->Restore ();
            if (hr != DSERR_BUFFERLOST) break;
            Sleep (10);
        }
        if (FAILED (FillBuffer ())) return FALSE;
    }
    g_pDSBuffer->SetPan    (Audio.pan);
    if (FAILED (g_pDSBuffer->Play (0, 0, dwLooped))) return FALSE;
    return TRUE;
}

void miDSound::StopBuffer (bool bResetPosition) {
    if (g_pDSBuffer == NULL) return;
    g_pDSBuffer->Stop ();
    if (bResetPosition) g_pDSBuffer->SetCurrentPosition (0);
}



/******************************** L i n u x ********************************/

#else

void CAudio::Init (unsigned woff, unsigned moff, unsigned wmax, unsigned mmax) {
    unsigned i, j;

    offset_wave = woff;
    offset_midi = moff;
    maxsound    = wmax;
    maxmusic    = mmax;
    if (maxsound > MAXWAVE_GUESS) maxsound = MAXWAVE_GUESS;
    if (maxmusic > MAXMIDI_GUESS) maxmusic = MAXMIDI_GUESS;

    for (i=0; theApp.HomeDir[i]; i++) TempFile[i] = theApp.HomeDir[i];
    TempFile[i] = 0;
    if (TempFile[i] == SLASHCHAR) i--;
    for (j=0; StrTable[Str_TempFile][j]; j++, i++) {
        TempFile[i] = StrTable[Str_TempFile][j];
        if (TempFile[i] == '\\') TempFile[i] = SLASHCHAR;
    }
    TempFile[i] = 0;
    for (i=0; i<5; i++) MidiStr[i] = StrTable[Str_MidiOpen][i];
    for (i=0; TempFile[i]; i++) MidiStr[i+5] = TempFile[i]; i += 5;
    for (j=0; StrTable[Str_MidiOpn1][j]; i++, j++) MidiStr[i] = StrTable[Str_MidiOpn1][j];

    theApp.HandleProgBar ();
    for (i=0; i<maxmusic + 1; i++) theApp.HandleProgBar ();
    Mix_OpenAudio (22050, MIX_DEFAULT_FORMAT, 2, 2048);
    SetVolume (volume);
}

void CAudio::Destroy (void) {
    Mix_CloseAudio ();
}

void CAudio::Suspend (void) {
    if (music) {
        Mix_HaltMusic ();
        curmusic = Mid_None;
    }
    if (sound) {
        Mix_HaltChannel (-1);
    }
}

void CAudio::Update (void) {
    unsigned        i;
    bool            isplaying;
    Mix_Music*      mm;
    static int      delay     = 0;
    static unsigned lastmusic = 0;
    if (music && music_on) {
        if (curmusic != newmusic) {
            if (curmusic == Mid_None) curmusic = newmusic;
            else                      curmusic = Mid_None;
            isplaying = false;
            Mix_HaltMusic ();
            i = MediaRef[curmusic + offset_midi];
            if (i != 0) {
                if (i & ALTLIB) {
                    if (theApp.AltLib) {
                        fseek (theApp.AltLib, i ^ ALTLIB, SEEK_SET);
                        i = pack.ReadBuffer (theApp.AltLib);
                    }
                } else {
                    fseek (theApp.MediaLib, i, SEEK_SET);
                    i = pack.ReadBuffer ();
                }
                if (i == 0) {
                    if (pack.WriteBufferPure (TempFile) == 0) {
                        mm = Mix_LoadMUS(TempFile);
                        if (mm == NULL)
							theApp.DebugMessage (Mix_GetError (), true);
                        if (Mix_PlayMusic (mm, 0) == -1)
							theApp.DebugMessage (Mix_GetError (), true);
                        isplaying = true;
                    }
                }
            }
        } else {
            isplaying = (Mix_PlayingMusic () != 0);
            if (isplaying == false && rnd_music) {
                if (delay) {
                    delay --;
                } else {
                    if (rnd_last - rnd_music < 3) lastmusic = 0;
                    while (newmusic == curmusic || newmusic == lastmusic) {
                        newmusic = random (rnd_last - rnd_music + 1) + rnd_music;
                    }
                    lastmusic = curmusic;
                    delay     = 12;
                    return;
                }
            }
        }
        if (isplaying == false) {
        }
    }
}

void CAudio::Sound (unsigned snum) {
    SDL_RWops *rw;
    Mix_Chunk *mc;
    if (sound && sound_on) {
        if (soundbuf[snum] == NULL) {
            if (MediaRef[snum + offset_wave] == 0) return;
            fseek (theApp.MediaLib, MediaRef[snum + offset_wave], SEEK_SET);
            soundbuf[snum] = pack.ExpandToRam (theApp.MediaLib);
        }
		rw = SDL_RWFromMem  (soundbuf[snum], pack.textsize);
		mc = Mix_LoadWAV_RW (rw, false);
		Mix_PlayChannel (-1, mc, 0);
    }
}

void CAudio::SetPan (unsigned) {}

void CAudio::SetVolume (unsigned nvol) {
    int voldata [9] = { 2, 5, 10, 20, 40, 60, 81, 103, 127 };

    if (nvol > 9) nvol = 9;
    volume = nvol;
	Mix_VolumeMusic (voldata[nvol] / 8);
}

miDSound::miDSound  (void) { }
miDSound::~miDSound (void) { }

#endif

#endif
