// version with intro panels

// misc junk
// actually if I ever port this, the intro and config panels must go

#include "Common\StdAfx.h"
#include "Audio.h"
#include "Compress.h"
#include "Graphics.h"
#include "Kernel.h"
#include "..\Resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CPieterApp theApp;


/***************************** Application *****************************/

BEGIN_MESSAGE_MAP(CPieterApp, CWinApp)
    //{{AFX_MSG_MAP(CPieterApp)
    //}}AFX_MSG
END_MESSAGE_MAP()

BOOL CPieterApp::InitInstance (void) {
    char          buf [16];
    unsigned long n;
    unsigned      r;
    unsigned char a,b,c;
    SYSTEMTIME    systime;
    GetSystemTime (&systime);
    day         = systime.wDay;
    month       = systime.wMonth;
    detailmode  = 1;
    network     = 1;
    regcode     = 1; // no.
    speed       = 250;
    speedadjust = true;
    MediaLib    = NULL;
    runlevel    = Run_Init;
    n           = MAXCNAME - 2;
    memset          (HomeDir, 0, MAXFNAME);
    memset          (CmpName, 0, MAXCNAME);
    GetComputerName (CmpName, &n);
    srand           (time (NULL));
    DeleteFile      (ErrorFile);
    DebugMessage    ("Launcher");

    r = GetVersion ();
    a =  (THE_MAGIC_NUMBER        & 0xff) ^ ((r & 0x000000ff));
    b = ((THE_MAGIC_NUMBER >>  8) & 0xff) ^ ((r & 0x0000ff00) >> 8);
    c = ((THE_MAGIC_NUMBER >> 16) & 0xff) ^ ((r & 0x00ff0000) >> 16);
    for (n=0; n<sizeof (theApp.CmpName); n++) {
	a *= (theApp.CmpName[n] + 1);
	b += (theApp.CmpName[n] + 2);
	c ^= (theApp.CmpName[n] * 3);
    }
    usercode = (a + (b << 8) + (c << 16)) % 10000000;
    if (usercode < 1000000) usercode += 1000000;

    #ifdef _DEBUG
	if (0)
    #endif
    {
	CIntroDlg dlg;

	m_pMainWnd = &dlg;
	if (CfgOpen ()) {
	    regcode = 0;
	    CfgRead ("Regcode", buf, 15);
	    regcode = MkNum (buf);
	    CfgRead ("Config",  buf, 15);
	    CfgClose ();
	    if (buf[0] != 0) {
		Audio.sound       = buf[0] == '1';
		Audio.directsound = buf[1] == '1';
		Audio.music       = buf[2] == '1';
		Audio.directmusic = buf[3] == '1';
		Screen.hires      = buf[4] == '1';
		detailmode        = buf[5] == '1';
		network           = buf[6] == '1';
	    }
	}
	r = dlg.DoModal ();
	if (CfgOpen (true)) {
	    for (n=0; n<8; n++) buf[n] = '0';
	    buf[n] = 0;
	    if (Audio.sound)       buf[0] = '1';
	    if (Audio.directsound) buf[1] = '1';
	    if (Audio.music)       buf[2] = '1';
	    if (Audio.directmusic) buf[3] = '1';
	    if (Screen.hires)      buf[4] = '1';
	    if (detailmode)        buf[5] = '1';
	    if (network)           buf[6] = '1';
	    CfgWrite ("Config", buf);
	    CfgWrite ("Regcode", MkStr (regcode));
	    CfgClose ();
	}
	if (r != IDOK) {
	    DebugMessage ("Launch aborted");
	    return FALSE;
	}
	ShowCursor (false);
    }

    m_pMainWnd = NULL;
    #ifndef USE_GLUT
	m_pMainWnd = &Screen;
	Screen.Create (IDD_SCREEN);
    #endif
    DebugMessage ("Initializing");
    HandleInit ();
    DebugMessage ("Main loop");
    #ifdef USE_GLUT
	glutMainLoop ();
	return FALSE;
    #endif

    return TRUE;
}

int CPieterApp::Run (void) {
    MSG      msg;
    CRect    rect;
    char     buf          [32];
    unsigned keys         = 0,
	     tick         = 0,
	     numtick      = 0,
	     ntime        = 0,
	     toggle_vsync = 5,
	     time         = clock (),
	     keypad []    = { VK_END,  VK_DOWN,  VK_NEXT,
			      VK_LEFT, VK_SPACE, VK_RIGHT,
			      VK_HOME, VK_UP,    VK_PRIOR };

    if (MediaLib) {
	speed = 20;
	if (CfgOpen ()) {
	    CfgRead ("Speed", buf, sizeof (buf));
	    CfgClose ();
	    if (MkNum (buf))  speed = MkNum (buf);
	    if (speed > 1000) {
		Screen.vsync = true;
		speed -= 1000;
	    } else Screen.vsync = false;
	    if (speed < 3)    speed = 3;
	    if (speed > 1000) speed = 1000;
	}
    }
    while (runlevel >= Run_Normal && runlevel <= Run_TitleSuspend) {
	if (runlevel != Run_Suspend && runlevel != Run_TitleSuspend) {
	    if (tick >= 100) {
		Screen.dispstate = (Screen.dispstate + 1) % 0xff;
		tick -= 100;
		HandleDraw ();
	    } else {
		Screen.animstate = (Screen.animstate + 1) % 0xff;
		tick += speed;
		HandleTick ();
		numtick ++;
		if (numtick == 60) {
		    numtick = 0;
		    ntime = clock ();
		    if (ntime != time) {
			if (speedadjust) {
			    speed = ((speed * 1000 / (ntime - time)) + speed) / 2;
			    if (Screen.vsync) {
				if (speed < 80 && toggle_vsync) {
				    Screen.vsync = false;
				    toggle_vsync --;
				    speed = 80;
				} else if (speed > 500) {
				    speed = 500;
				}
			    } else {
				if (speed < 3) {
				    speed = 3;
				} else if (speed > 130 && toggle_vsync) {
				    speed = 100;
				    Screen.vsync = true;
				    toggle_vsync --;
				}
			    }
			} else speedadjust = true;
			time = ntime;
		    }
		}
	    }
	}
	if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE) == 0) continue;
	if (Screen.fullscreen || Screen.usewindow == false) {
	    if (msg.message >= WM_NCMOUSEMOVE && msg.message <= WM_NCMBUTTONDBLCLK) {
		msg.message += WM_MOUSEMOVE - WM_NCMOUSEMOVE;
	    } else if (msg.message >= WM_MOUSEMOVE && msg.message <= WM_MBUTTONDBLCLK) {
		msg.lParam += 0x00160003;
	    }
	}
	switch (msg.message) {
	    case WM_KEYDOWN:
	    case WM_SYSKEYDOWN:
		switch (msg.wParam) {
		    case VK_SHIFT:   keys |= Key_Shift;    break;
		    case VK_CONTROL: keys |= Key_Control;  break;
		    case VK_MENU:    keys |= Key_Alt;      break;
		    case VK_F10:     //if (MediaLib == NULL) 
				     runlevel = Run_Abort;
				     break;
		    default:         if (msg.wParam >= VK_NUMPAD1 && msg.wParam <= VK_NUMPAD9)
					 msg.wParam = keypad[msg.wParam - VK_NUMPAD1];
				     HandleKeyPress (msg.wParam, keys);
		}
		break;
	    case WM_KEYUP:
	    case WM_SYSKEYUP:
		switch (msg.wParam) {
		    case VK_SHIFT:   keys &= -1 ^ Key_Shift;   break;
		    case VK_CONTROL: keys &= -1 ^ Key_Control; break;
		    case VK_MENU:    keys &= -1 ^ Key_Alt;     break;
		    default:         if (msg.wParam >= VK_NUMPAD1 && msg.wParam <= VK_NUMPAD9)
					 msg.wParam = keypad[msg.wParam - VK_NUMPAD1];
				     HandleKeyUp (msg.wParam, keys);
		}
		break;
	    case WM_MOUSEMOVE:     HandleMouseMove (msg.lParam & 0xffff, msg.lParam >> 16, keys); break;
	    case WM_LBUTTONDOWN:
	    case WM_LBUTTONDBLCLK: keys |= Key_MouseL;
				   HandleMouseClick (VE_LeftClick,  keys); break;
	    case WM_MBUTTONDOWN:
	    case WM_MBUTTONDBLCLK: HandleMouseClick (VE_MidClick,   keys); break;
	    case WM_RBUTTONDOWN:
	    case WM_RBUTTONDBLCLK: HandleMouseClick (VE_RightClick, keys); break;
	    case WM_LBUTTONUP:     keys &= -1 ^ Key_MouseL;
				   HandleMouseUnClk (VE_LeftClick,  keys);
	    case WM_MBUTTONUP:     HandleMouseUnClk (VE_MidClick,   keys); break;
	    case WM_RBUTTONUP:     HandleMouseUnClk (VE_RightClick, keys); break;
	    case WM_PAINT:         Screen.GetWindowRect (&rect);
				   Screen.ValidateRect  (&rect); break;
	    case WM_CLOSE:
	    case WM_NULL:
	    case WM_DESTROY:       runlevel = Run_Abort; break;
	    case WM_CONTEXTMENU:
	    case WM_KEY_F1_DOWN:   break;
		case WM_SYSCOMMAND:    if (msg.wParam == SC_SCREENSAVE
				   ||  msg.wParam == SC_MONITORPOWER) break;
	    case WM_TIMER:
	    case WM_COMMAND:
	    case WM_QUIT:
	    case WM_NCMOUSEMOVE:
	    case WM_NCLBUTTONDOWN:
	    case WM_NCLBUTTONDBLCLK:
	    case WM_NCLBUTTONUP:
	    case WM_NCRBUTTONDOWN:
	    case WM_NCRBUTTONDBLCLK:
	    case WM_NCRBUTTONUP:
	    case WM_NCMBUTTONDOWN:
	    case WM_NCMBUTTONDBLCLK:
	    case WM_NCMBUTTONUP:   TranslateMessage (&msg);
				   DispatchMessage  (&msg);
				   break; // temporary solution
	    default:               sprintf (buf, "Message = %x\n", msg.message); // "winuser.h"
				   TRACE0           (buf);
				   DebugMessage     (buf);
				   TranslateMessage (&msg);
				   DispatchMessage  (&msg);
	}
    }
    if (CfgOpen (true)) {
	CfgWrite ("Speed",   MkStr (speed + (1000 * Screen.vsync)));
	CfgWrite ("Regcode", MkStr (regcode));
	CfgClose ();
    }
    HandleExit ();
    return 0;
}

void CPieterApp::HandleSuspend (bool suspend) {
    if (suspend) {
	if      (runlevel == Run_Title)  runlevel = Run_TitleSuspend;
	else if (runlevel == Run_Normal) runlevel = Run_Suspend;
	else return;
	KillClipboard ();
	Audio.Suspend ();
    } else {
	if      (runlevel == Run_Suspend)      runlevel = Run_Normal;
	else if (runlevel == Run_TitleSuspend) runlevel = Run_Title;
	else return;
	if (Screen.Restore () == false) runlevel = Run_ScreenError;
    }
}

char* CPieterApp::CommandLine (void) {
    return m_lpCmdLine;
}

void CPieterApp::AddToRecentFiles (const char *fname) {
    SHAddToRecentDocs (SHARD_PATH, fname);
}

bool CPieterApp::ChangeDirectory (const char *path, bool create) {
    if (create) CreateDirectory (path, NULL);
    return SetCurrentDirectory (path) != 0;
}

void CPieterApp::DebugMessage (char *msg, bool onscr) {
    FILE *file;
    char *rlst[] = { "Startup", "Running", "Waiting", "TitleSc", "Waiting",
		     "Exiting", "ScrnErr", "Mem Err", "FileErr", "LogcErr" };
    if (msg == NULL) {
	msg = "Normal exit";
	onscr = false;
    }
    last_msg = msg;
    debug_return;
    ChangeDirectory (HomeDir);
    file = fopen (ErrorFile, "ab");
    if (file) {
	fprintf (file, "[%s] %s\r\n", rlst[runlevel], msg);
	fclose (file);
    }
    if (onscr) {
	ShellExecute (NULL, NULL, ErrorFile, NULL, NULL, SW_NORMAL);
    }
}

void CPieterApp::KillClipboard (void) {
    HGLOBAL h;
    char    filler [4] = "  ";
    if (MediaLib) {
	OpenClipboard    (Screen.m_hWnd);
	EmptyClipboard   ();
	h = GlobalAlloc  (GHND | GMEM_SHARE, 4);
	strcpy           ((LPSTR) GlobalLock (h), filler);
	GlobalUnlock     (h);
	SetClipboardData (CF_TEXT, h);
	CloseClipboard   (); 
    }
}

void CPieterApp::GetRegInfo (char *ext, unsigned ver) {
    unsigned long i, j;
    long          k;
    char          buf [512];
    GetCurrentDirectory (MAXFNAME - 2, HomeDir);
    MediaLib = NULL;
    debug_return;
    sprintf (buf, "%s%s.dat", DataDir, AppID);
    MediaLib = fopen (buf, "rb");
    if (MediaLib) {
	if (RegCreateKey (HKEY_CLASSES_ROOT, ext, &key) == 0) {
	    RegSetValue (key, "", REG_SZ, AppID, 0);
	    RegCloseKey (key);
	}
	if (RegCreateKey (HKEY_CLASSES_ROOT, AppID, &key) == 0) {
	    sprintf (buf, "%s data file", AppID);
	    RegSetValue (key, "", REG_SZ, buf, 0);
	    sprintf (buf, "%s\\%s.exe %%1", HomeDir, AppID);
	    RegSetValue (key, "shell\\open\\command", REG_SZ, buf, 0xff);
	    buf[strlen(buf) - 2] = ',';
	    RegSetValue (key, "DefaultIcon", REG_SZ, buf, 0xff);
	    RegCloseKey (key);
	}
    } else {
	if (RegOpenKey (HKEY_CLASSES_ROOT, AppID, &key) == 0) {
	    k = MAXFNAME;
	    if (RegQueryValue (key, "shell\\open\\command", HomeDir, &k) == 0) {
		for (i=0; HomeDir[i]; i++)
		    if (HomeDir[i] == '\\') j = i;
		HomeDir[j] = 0;
		if (ChangeDirectory (HomeDir)) {
		    MediaLib = fopen (buf, "rb");
		}
	    }
	    RegCloseKey (key);
	}
    }
    if (MediaLib == NULL) {
	runlevel = Run_FileError;
    } else {
	for (i=0; AppName[i]; i++) {
	    if (fgetc (MediaLib) != AppName[i]) {
		runlevel = Run_FileError;
		break;
	    }
	}
	fread (&i, sizeof (int), 1, MediaLib);
	if (i != ver || ferror (MediaLib)) runlevel = Run_FileError;
    }
    for (i=1; MediaRef[i] != -1; i++) {
	if (MediaRef[i])
	    MediaRef[i] ^= ((i + 1) % 7) * GARBLE;
    }
}

bool CPieterApp::CfgOpen (bool create) {
    if (RegOpenKey   (HKEY_CLASSES_ROOT, AppID, &key) == 0) return true;
    if (create) {
	if (RegCreateKey (HKEY_CLASSES_ROOT, AppID, &key) == 0) return true;
    }
    return false;
}

void CPieterApp::CfgClose (void) {
    if (key) RegCloseKey (key);
}

void CPieterApp::CfgRead (char *id, char *buf, long len) {
    if (id && buf && len) {
	memset (buf, 0, len);
	if (key) RegQueryValue (key, id, buf, &len);
    }
}

void CPieterApp::CfgWrite (char *id, char *buf) {
    unsigned len;
    if (key && id && buf) {
	for (len = 0; buf[len]; len ++);
	RegSetValue (key, id, REG_SZ, buf, len);
    }
}

unsigned CPieterApp::CopyFile (const char *fname, const char *dest) {
    unsigned i;
    i = pack.ReadBufferPure (fname);
    if (i) return i;
    i = pack.WriteBufferPure (dest);
    return i;
}

unsigned CPieterApp::DeleteFile (const char *fname) {
    return ::DeleteFile (fname);
}

void CPieterApp::FileAttr (const char *fname, unsigned attr) {
    SetFileAttributes (fname, attr);
}

bool CPieterApp::FindFile (const char *fname) {
    memset (&filestruct, 0, sizeof (filestruct));
    fh = FindFirstFile (fname, &filestruct);
    if (fh == INVALID_HANDLE_VALUE) {
	FindClose (fh);
	return false;
    }
    return true;
}

bool CPieterApp::FindNext (void) {
    if (FindNextFile (fh, &filestruct) == 0) {
	FindClose (fh);
	return false;
    }
    return true;
}



/**************************** Glut redirects ****************************/

#ifdef USE_GLUT

void __cdecl GlutKey (unsigned char key, int, int) {
    if (key >= 'a' && key <= 'z') key += 'A' - 'a';
    theApp.HandleKeyPress (key, glutGetModifiers ());
}

void __cdecl GlutSKey (int key, int, int) {
    switch (key) {
	case 0x7f:               key = VK_DELETE; break;
	case GLUT_KEY_F1:        key = VK_F1;     break;
	case GLUT_KEY_F2:        key = VK_F2;     break;
	case GLUT_KEY_F3:        key = VK_F3;     break;
	case GLUT_KEY_F4:        key = VK_F4;     break;
	case GLUT_KEY_F5:        key = VK_F5;     break;
	case GLUT_KEY_F6:        key = VK_F6;     break;
	case GLUT_KEY_F7:        key = VK_F7;     break;
	case GLUT_KEY_F8:        key = VK_F8;     break;
	case GLUT_KEY_F9:        key = VK_F9;     break;
	case GLUT_KEY_F10:       key = VK_F10;    break;
	case GLUT_KEY_F11:       key = VK_F11;    break;
	case GLUT_KEY_F12:       key = VK_F2;     break;
	case GLUT_KEY_LEFT:      key = VK_LEFT;   break;
	case GLUT_KEY_UP:        key = VK_UP;     break;
	case GLUT_KEY_RIGHT:     key = VK_RIGHT;  break;
	case GLUT_KEY_DOWN:      key = VK_DOWN;   break;
	case GLUT_KEY_PAGE_UP:   key = VK_PRIOR;  break;
	case GLUT_KEY_PAGE_DOWN: key = VK_NEXT;   break;
	case GLUT_KEY_HOME:      key = VK_HOME;   break;
	case GLUT_KEY_END:       key = VK_END;    break;
	case GLUT_KEY_INSERT:    key = VK_INSERT; break;
    }
    theApp.HandleKeyPress (key, glutGetModifiers ());
}

void __cdecl GlutMouse (int x, int y) {
    GlutClick (0, 0, x, y);
}

void __cdecl GlutClick (int button, int state, int x, int y) {
    static unsigned lmouse = 0;
    unsigned b1;
    theApp.HandleMouseMove (x, y, glutGetModifiers ());
    if (state == GLUT_DOWN) switch (button) {
	case GLUT_LEFT_BUTTON:   lmouse = Key_MouseL;
				 b1 = VE_LeftClick;  break;
	case GLUT_RIGHT_BUTTON:  b1 = VE_RightClick; break;
	case GLUT_MIDDLE_BUTTON: b1 = VE_LeftDouble; break;
    } else {
	if (button == GLUT_LEFT_BUTTON) lmouse = 0;
    }
    theApp.HandleMouseClick (b1, glutGetModifiers () | lmouse);
}

void __cdecl GlutSuspend (int vis) {
    if (vis == GLUT_VISIBLE) theApp.HandleSuspend (false);
    else                     theApp.HandleSuspend (true);
}

void __cdecl GlutIdle (void) {
    if (theApp.runlevel == Run_Normal || theApp.runlevel = Run_Title) {
	glutPostRedisplay ();
    } else if (theApp.runlevel != Run_Suspend && theApp.runlevel != Run_TitleSuspend) {
	theApp.HandleExit ();
	exit (0);
    }
}

void __cdecl GlutDraw (void) {
    /* Copy speed routine from theApp::Run () */
    glClear           (GL_COLOR_BUFFER_BIT);
    theApp.HandleTick ();
    theApp.HandleDraw ();
    if (glGetError ()) theApp.runlevel = Run_ScreenError;
}

#endif



/******************************* CScreen *******************************/

BEGIN_MESSAGE_MAP(CScreen, CDialog)
    //{{AFX_MSG_MAP(CScreen)
    ON_WM_ACTIVATE()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CScreen::OnInitDialog (void) {
    //CDialog::OnInitDialog (); // why, or why not?
    m_hIcon = theApp.LoadIcon (ICN_MAIN);
    SetIcon (m_hIcon, TRUE);
    SetIcon (m_hIcon, FALSE);
    return TRUE;
}

CScreen::~CScreen (void) {
    DestroyWindow ();
}

void CScreen::OnActivate (UINT nState, CWnd* pWndOther, BOOL bMinimized) {
    if (nState) theApp.HandleSuspend (false);
    else        theApp.HandleSuspend (true);
    CDialog::OnActivate (nState, pWndOther, bMinimized);
}

HCURSOR CScreen::OnQueryDragIcon (void) {
    return (HCURSOR) m_hIcon;
}

void CScreen::OnPaint (void) {
    unsigned x,
	     y,
	     cxIcon,
	     cyIcon;
    CRect    rect;
    if (IsIconic ()) {
	theApp.DebugMessage ("Iconic paint!\n");
	TRACE0 ("Iconic paint\n"); // does this ever happen?
	CPaintDC dc (this);
	SendMessage (WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc (), 0);
	cxIcon = GetSystemMetrics (SM_CXICON);
	cyIcon = GetSystemMetrics (SM_CYICON);
	GetClientRect (&rect);
	x = (rect.Width  () - cxIcon + 1) / 2;
	y = (rect.Height () - cyIcon + 1) / 2;
	dc.DrawIcon (x, y, m_hIcon);
    } else {
	Screen.GetWindowRect (&rect);
	Screen.ValidateRect  (&rect);
    }
}



/**************************** Intro Dialog ****************************/

BEGIN_MESSAGE_MAP(CIntroDlg, CDialog)
    //{{AFX_MSG_MAP(CIntroDlg)
    ON_BN_CLICKED(IDCFG,  OnCfg)
    ON_BN_CLICKED(IDINFO, OnInfo)
    ON_BN_CLICKED(IDREG,  OnRegist)
    ON_BN_CLICKED(IDWEB,  OnWeb)
    ON_WM_PAINT()
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

CIntroDlg::CIntroDlg (void) : CDialog (IDD_INTRO, NULL) { }

void CIntroDlg::DoDataExchange (CDataExchange* pDX) {
    CDialog::DoDataExchange (pDX);
    //{{AFX_DATA_MAP(CIntroDlg)
    DDX_Control(pDX, IDREG, RegBtn);
    //}}AFX_DATA_MAP
}

void CIntroDlg::OnCfg (void) {
    CConfigDlg dlg;
    dlg.DoModal ();
}

void CIntroDlg::OnInfo (void) {
    ShellExecute (GetSafeHwnd (), NULL, DataDir "readme.htm", NULL, NULL, SW_MAXIMIZE);
}

void CIntroDlg::OnRegist (void) {
    CRegDlg dlg;
    if (theApp.regcode == 0) {
	dlg.first = true;
	dlg.DoModal ();
	if (theApp.regcode) {
	    AfxMessageBox ("Thank you for registering!");
	    RegBtn.ShowWindow (SW_HIDE);
	}
    }
}

void CIntroDlg::OnWeb (void) {
    // this line causes a gpf
    ShellExecute (NULL, NULL, "http:/" "/www.liacs.nl/~psimoons", NULL, NULL, SW_MAXIMIZE);
    OnCancel ();
}

void CIntroDlg::OnPaint (void) {
    static bool first = true;
    if (first) {
	m_hIcon = theApp.LoadIcon (ICN_MAIN);
	SetIcon       (m_hIcon, TRUE);
	SetIcon       (m_hIcon, FALSE);
	SetWindowText (AppID);
	//if (theApp.regcode == 0) RegBtn.ShowWindow (SW_SHOW);
	first = false;
    }
    CDialog::OnPaint ();
}

BOOL CIntroDlg::PreTranslateMessage (MSG* pMsg) {
    if (pMsg->message == WM_KEYDOWN) {
	switch (pMsg->wParam) {
	    case 'C': OnCfg    (); return TRUE;
	    case 'E': OnCancel (); return TRUE;
	    case 'I': OnInfo   (); return TRUE;
	    case 'P': OnOK     (); return TRUE;
	    case 'R': OnRegist (); return TRUE;
	    case 'W': OnWeb    (); return TRUE;
	}
    }
    return CDialog::PreTranslateMessage (pMsg);
}



/*************************** Config Dialog ***************************/

BEGIN_MESSAGE_MAP(CConfigDlg, CDialog)
    //{{AFX_MSG_MAP(CConfigDlg)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

CConfigDlg::CConfigDlg (void) : CDialog (IDD_CONFIG, NULL) { }

void CConfigDlg::DoDataExchange (CDataExchange* pDX) {
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CConfigDlg)
    DDX_Check (pDX, IDC_MUSIC,  Audio.music);
    DDX_Check (pDX, IDC_DMUSIC, Audio.directmusic);
    DDX_Check (pDX, IDC_SOUND,  Audio.sound);
    DDX_Check (pDX, IDC_DSOUND, Audio.directsound);
    DDX_Check (pDX, IDC_HIRES,  Screen.hires);
    DDX_Check (pDX, IDC_DETAIL, theApp.detailmode);
    //}}AFX_DATA_MAP
}

void CConfigDlg::OnCancel (void) {
    OnOK ();
}



/*************************** Register Dialog ***************************/

BEGIN_MESSAGE_MAP(CRegDlg, CDialog)
    //{{AFX_MSG_MAP(CRegDlg)
    ON_BN_CLICKED(IDFORM, OnForm)
    ON_WM_PAINT()
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

CRegDlg::CRegDlg (void) : CDialog (IDD_REGIST, NULL) { }

void CRegDlg::DoDataExchange (CDataExchange* pDX) {
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CRegDlg)
    DDX_Control(pDX, IDC_USERCODE, Ed_Userkey);
    DDX_Control(pDX, IDC_REGKEY,   Ed_Regkey);
    //}}AFX_DATA_MAP
}

void CRegDlg::OnPaint (void) {
    if (first) {
	Ed_Userkey.SetWindowText (MkStr (theApp.usercode));
	if (theApp.regcode != 0)
	    Ed_Regkey.SetWindowText (MkStr (theApp.regcode));
	Ed_Regkey.SetLimitText   (9);
	Ed_Regkey.SetSel         (0, 9);
	Ed_Regkey.SetFocus       ();
	first = false;
    }
    CDialog::OnPaint ();
}

BOOL CRegDlg::PreTranslateMessage (MSG* pMsg) {
    if (pMsg->message == WM_KEYDOWN) {
	switch (pMsg->wParam) {
	    case 'O':       OnForm   (); return TRUE;
	    case VK_ESCAPE: OnCancel (); return TRUE;
	}
    }
    return CDialog::PreTranslateMessage (pMsg);
}

void CRegDlg::OnForm (void) {
    ShellExecute (GetSafeHwnd (), NULL, DataDir "order.txt", NULL, NULL, SW_MAXIMIZE);
}

void CRegDlg::OnOK (void) {
    char buf[12];
    Ed_Regkey.GetLine (0, buf, 11);
    buf[11] = 0;
    theApp.regcode = MkNum (buf);
    CDialog::OnOK ();
}



/*************************** File Linked List ***************************/

CFileList::CFileList (void) {
    memset (this, 0, sizeof (CFileList));
}

void CFileList::Insert (const char *nwname) {
    unsigned  i = 0;
    CFileList *tmp,
	      *f1,
	      *f2;
    if (fname[0] == 0) {
	for (i=0; i < MAXFNAME - 1 && nwname[i]; i++)
	    fname[i] = nwname[i];
	fname[i] = 0;
	return;
    }
    tmp = new CFileList;
    if (tmp == NULL) {
	theApp.runlevel = Run_MemError;
	return;
    }
    for (i=0; fname[i] != 0; i++) {
	if (fname[i] > nwname[i]) {
	    tmp->next = next; next = tmp;
	    for (i=0; i<MAXFNAME; i++) tmp->fname[i] = fname[i];
	    for (i=0; i<MAXFNAME - 1 && nwname[i]; i++)
		fname[i] = nwname[i];
	    fname[i] = 0;
	    return;
	}
	if (fname[i] < nwname[i]) break;
    }
    for (i=0; i<MAXFNAME; i++) {
	tmp->fname[i] = nwname[i];
	if (nwname[i] == 0) break;
    }
    for (f1 = next, f2 = this; f1; f2 = f1, f1 = f1->next) {
	for (i=0; f1->fname[i] != 0; i++) {
	    if (f1->fname[i] > nwname[i]) {
		tmp->next = f1;
		f2->next  = tmp;
		return;
	    }
	    if (f1->fname[i] < nwname[i]) break;
	}
    }
    f2->next = tmp;
}

void CFileList::Remove (CFileList *target) {
    unsigned  i;
    CFileList *tmp,
	      *f1;
    if (target == this) {
	if (next == NULL) {
	    fname[0] = 0; return;
	}
	for (i=0; i<MAXFNAME; i++)
	    fname[i] = next->fname[i];
	tmp = next;
	next = next->next;
	delete tmp;
	return;
    }
    for (f1 = this; f1 != NULL; f1 = f1->next) {
	if (f1->next == target) {
	    tmp = f1->next;
	    f1->next = f1->next->next;
	    delete tmp;
	}
    }
}

void CFileList::Delete (void) {
    unsigned i;
    CFileList *f1 = next,
	      *f2;
    while (f1 != NULL) {
	f2 = f1->next;
	delete f1;
	f1 = f2;
    }
    for (i=0; i<MAXFNAME; i++) fname[i] = 0;
    next = NULL;
}



/**************************** Miscellaneous ****************************/

char *MkStr (long num) {
    static char Str[12] = "\0\0\0\0\0\0\0\0\0\0\0";
    char        neg     = (num<0),
		r       = 11;
    if (neg) num = -num;
    if (num > 999999999) num = 999999999;
    do {
	r--;
	Str[r] = ((num % 10) + '0');
	num /= 10;
    } while (num);
    if (neg) {
	r--;
	Str[r] = '-';
    }
    return &Str[r];
}

int MkNum (char *string) {
    int i,
	j,
	n = 0;
    for (i=0; string[i] != 0; i++) {
	j = string[i];
	if (j >= '0' && j <= '9') {
	    n *= 10; n += (j - '0');
	} else if (n) break;
    }
    return n;
}
