#ifdef STDAFX_H
#error Double include.
#endif
#define STDAFX_H


#undef PURE_ALLEGRO



/******************************** Windows ********************************/

#ifndef PURE_ALLEGRO
#ifndef LINUX

#define VC_EXTRALEAN
#define WIN32_LEAN_AND_MEAN
#define SLASHCHAR '\\'
#define SLASHSTR  "\\"
#ifdef  USE_ALLEGRO
#define BITMAP _WIN_BMP
#define IDirectDrawSurface _WIN_IDDS
#endif

#include <AfxWin.h>
#include <AfxSock.h>
#include <ShlObj.h>
#include <SetJmp.h>

#pragma warning(disable:4244) /* Conversion possible data loss */
#pragma warning(disable:4711) /* Selected for inline expansion */

#ifndef _DEBUG
    #include <\Prog\Dx7\Include\DDraw.h>
    #define debug_return 0
    #define MMNOAUX
    #define MMNODRV
    #define MMNOMIXER
    #define MMNOMMSYSTEM
    #define MMNOTIMER
    #define MMNOJOYSTICK
    #define XMD_H
    #undef  FAR
    extern "C" {
        #include "JpegLib.h"
    }
    #include <MMSystem.h>
    #include <\Prog\Dx7\Include\DMusicI.h>
    #include <DSound.h>
#else
    #include <DDraw.h>
    DEFINE_GUID (IID_IDirectDrawGammaControl, 0x69C11C3E,0xB46B,0x11D1,0xAD,0x7A,0x00,0xC0,0x4F,0xC2,0x9B,0x4E );
    #define DirectDrawCreateEx(a,b,c,d) DirectDrawCreate (a,(IDirectDraw**)b,d)
    #define debug_return    return
    #define METHODDEF(x)    x
    #define JMSG_LENGTH_MAX 1
    #define JDCT_FASTEST    1
    typedef int  IDirectMusicPerformance;
    typedef int  IDirectMusicLoader;
    typedef int  IDirectMusicSegment;
    typedef int  DMUS_OBJECTDESC;
    typedef int  HMMIO;
    typedef int  LPDIRECTSOUND;
    typedef int  LPDIRECTSOUNDBUFFER;
    typedef int  LPDIRECTSOUNDNOTIFY;
    typedef int  MMCKINFO;
    typedef int  WAVEFORMATEX;
    typedef int  j_func  (void*, void*);
    typedef void j_func2 (struct jpeg_decompress_struct*);
    class IDirectDrawGammaControl {
        public:
        int n;
        void inline SetGammaRamp (int, void*) {}
    };
    struct DDGAMMARAMP {
        int red   [256];
        int green [256];
        int blue  [256];
    };
    struct jpeg_decompress_struct {
        unsigned dct_method,
                 do_block_smoothing,
                 do_fancy_upsampling,
                 output_height,
                 output_scanline,
                 output_width,
                 *setjmp_buffer;
        jpeg_decompress_struct *err;
        j_func   *format_message;
        j_func2  *error_exit;
    };
    typedef jpeg_decompress_struct* j_common_ptr;
    typedef jpeg_decompress_struct  jpeg_error_mgr;
#endif

enum {
    WM_KEY_F1_DOWN = 0x4D,
    WM_SYSHOVER    = 0x76,
};

enum {
    VK_COLON       = 0xBA,
    VK_EQUALSIGN   = 0xBB,
    VK_COMMA       = 0xBC,
    VK_MINUS       = 0xBD,
    VK_PERIOD      = 0xBE,
    VK_SLASH       = 0xBF,
    VK_APOSTROPHE  = 0xC0,
    VK_LEFTBRACK   = 0xDB,
    VK_BACKSLASH   = 0xDC,
    VK_RIGHTBRACK  = 0xDD,
    VK_QUOTE       = 0xDE,
    VK_BACKSLASH2  = 0xE2,
    VK_0           = '0',
    VK_A           = 'A',
    VK_LTR         = VK_A - 'A',
    VK_HACK        = 0x1ff,
};

/* Crazy Allegro Hybrid */
#ifdef USE_ALLEGRO
    #undef   BITMAP
    #undef   ASSERT
    #undef   TRACE
    #define  ALLEGRO_NO_MAGIC_MAIN
    #include <allegro.h>
    #undef   IDirectDrawSurface
    typedef  BITMAP IDirectDrawSurface;
#endif

typedef IDirectDrawSurface SDL_Surface;
typedef int DIR;



/******************************* L i n u x *******************************/

#else

#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <sys/types.h>
#include <sys/stat.h>
#include <setjmp.h>
#ifndef FEW_INCLUDES
#include "SDL.h"
#include "SDL_mixer.h"
#include <dirent.h>
#include <netdb.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#endif
extern "C" {
    #include "JpegLib.h"
}

#ifdef _WINDOWS
#include "Common/Fake_Lnx.h"
#endif

#define __AFXWIN_H__
#define DECLARE_MESSAGE_MAP()
#define afx_msg
#define TRACE0(n)
#define TRACE1(n,a)
#define TRACE2(n,a,b)
#define TRACE3(n,a,b,c)
#define DEBUG_ONLY(x)
#define debug_return
#define SW_NORMAL   0
#define SW_MAXIMIZE 0
#define SLASHCHAR '/'
#define SLASHSTR  "/"

typedef bool   BOOL;
typedef char   CHAR;
typedef char   TCHAR;
typedef Uint8  BYTE;
typedef Uint8* PBYTE;
typedef Uint8  UCHAR;
typedef Sint16 WORD;
typedef Uint32 DWORD;
typedef Uint32 UINT;
typedef Uint32 ULONG;
typedef SDL_Surface IDirectDrawSurface;

typedef int  CWnd;
typedef int  DDBLTFX;
typedef int  DDGAMMARAMP;
typedef int  DDSURFACEDESC;
typedef int  DMUS_OBJECTDESC;
typedef int  FILETIME;
typedef int  HKEY;
typedef int  HMMIO;
typedef int  HRESULT;
typedef int  IDirectDrawGammaControl;
typedef int  IDirectMusicLoader;
typedef int  IDirectMusicPerformance;
typedef int  IDirectMusicSegment;
typedef int  MMCKINFO;
typedef int  SOCKET;
typedef int  WAVEFORMATEX;
typedef int* HCURSOR;
typedef int* HICON;
typedef int* LPDIRECTSOUND;
typedef int* LPDIRECTSOUNDBUFFER;
typedef int* LPDIRECTSOUNDNOTIFY;

class  DDraw   { public:
    void RestoreDisplayMode (void) { }
    void Release            (void) { }
};
class  CWinApp {};
class  CDialog {};
struct CString;
typedef DDraw* LPDIRECTDRAW;

#define SOCKADDR_IN sockaddr_in
#define FILE_ATTRIBUTE_DIRECTORY 0x00000010
#define abs(x) abs((int)(x))

typedef struct {
    DWORD    dwFileAttributes;
    FILETIME ftCreationTime;
    FILETIME ftLastAccessTime;
    FILETIME ftLastWriteTime;
    DWORD    nFileSizeHigh;
    DWORD    nFileSizeLow;
    DWORD    dwReserved0;
    DWORD    dwReserved1;
    CHAR     cFileName          [260];
    CHAR     cAlternateFileName  [16];
} WIN32_FIND_DATA;

#ifndef FEW_INCLUDES
enum {
    VK_ADD        = SDLK_KP_PLUS,
    VK_APOSTROPHE = SDLK_BACKQUOTE,
    VK_BACK       = SDLK_BACKSPACE,
    VK_BACKSLASH  = SDLK_BACKSLASH,
    VK_BACKSLASH2 = 0x7fff,
    VK_CLEAR      = SDLK_DELETE,
    VK_COLON      = SDLK_COLON,
    VK_COMMA      = SDLK_COMMA,
    VK_CONTROL    = SDLK_LCTRL,
    VK_DELETE     = SDLK_DELETE,
    VK_DIVIDE     = SDLK_KP_DIVIDE,
    VK_DOWN       = SDLK_DOWN,
    VK_END        = SDLK_END,
    VK_EQUALSIGN  = SDLK_EQUALS,
    VK_ESCAPE     = SDLK_ESCAPE,
    VK_F1         = SDLK_F1,
    VK_F2         = SDLK_F2,
    VK_F3         = SDLK_F3,
    VK_F4         = SDLK_F4,
    VK_F5         = SDLK_F5,
    VK_F6         = SDLK_F6,
    VK_F7         = SDLK_F7,
    VK_F8         = SDLK_F8,
    VK_F9         = SDLK_F9,
    VK_F10        = SDLK_F10,
    VK_F11        = SDLK_F11,
    VK_F12        = SDLK_F12,
    VK_HOME       = SDLK_HOME,
    VK_INSERT     = SDLK_INSERT,
    VK_LEFT       = SDLK_LEFT,
    VK_LEFTBRACK  = SDLK_LEFTBRACKET,
    VK_MENU       = SDLK_LALT,
    VK_MINUS      = SDLK_MINUS,
    VK_MULTIPLY   = SDLK_KP_MULTIPLY,
    VK_NEXT       = SDLK_PAGEDOWN,
    VK_NUMPAD0    = SDLK_KP0,
    VK_NUMPAD1    = SDLK_KP1,
    VK_NUMPAD2    = SDLK_KP2,
    VK_NUMPAD3    = SDLK_KP3,
    VK_NUMPAD4    = SDLK_KP4,
    VK_NUMPAD5    = SDLK_KP5,
    VK_NUMPAD6    = SDLK_KP6,
    VK_NUMPAD7    = SDLK_KP7,
    VK_NUMPAD8    = SDLK_KP8,
    VK_NUMPAD9    = SDLK_KP9,
    VK_PAUSE      = SDLK_PAUSE,
    VK_PERIOD     = SDLK_PERIOD,
    VK_PRIOR      = SDLK_PAGEUP,
    VK_QUOTE      = SDLK_QUOTE,
    VK_RCONTROL   = SDLK_RCTRL,
    VK_RETURN     = SDLK_RETURN,
    VK_RIGHT      = SDLK_RIGHT,
    VK_RIGHTBRACK = SDLK_RIGHTBRACKET,
    VK_SHIFT      = SDLK_LSHIFT,
    VK_SLASH      = SDLK_SLASH,
    VK_SPACE      = SDLK_SPACE,
    VK_SUBTRACT   = SDLK_KP_MINUS,
    VK_TAB        = SDLK_TAB,
    VK_UP         = SDLK_UP,
    VK_0          = '0',
    VK_A          = 'A',
    VK_LTR        = VK_A - 'A',
    VK_HACK       = 0x1ff
};
#endif

#endif

#else


/***************************** A l l e g r o *****************************/

    #pragma warning(disable:4127) /* Conditional expression is constant            */
    #pragma warning(disable:4505) /* Unreferenced local function has been removed  */
    #pragma warning(disable:4514) /* Unreferenced inline function has been removed */
    #define __AFXWIN_H__
    #define afx_msg
    #define DECLARE_MESSAGE_MAP()
    #define SLASHCHAR '\\'
    #define SLASHSTR  "\\"
    #define DEBUG_NEW new
    #define TRACE0(n)
    #define TRACE1(n,a)
    #define TRACE2(n,a,b)
    #define TRACE3(n,a,b,c)
    #define DEBUG_ONLY(x)
    #define FILE_ATTRIBUTE_DIRECTORY 0x00000010
    #define SW_NORMAL   0
    #define SW_MAXIMIZE 0

    typedef unsigned char UCHAR;
    typedef unsigned long ULONG;
    typedef unsigned int  UINT;
    typedef unsigned long DWORD;
    typedef unsigned short WORD;
    typedef unsigned char *PBYTE;
    typedef unsigned char BYTE;
    typedef void* LPVOID;
    typedef char CHAR;
    typedef char TCHAR;
    typedef long LONG;
    typedef int  BOOL;
    typedef int  CWnd;
    typedef int  DDBLTFX;
    typedef int  DDGAMMARAMP;
    typedef int  DDSURFACEDESC;
    typedef int  DMUS_OBJECTDESC;
    typedef int  FILETIME;
    typedef int  HKEY;
    typedef int  HMMIO;
    typedef int  HRESULT;
    typedef int  IDirectDrawGammaControl;
    typedef int  IDirectMusicLoader;
    typedef int  IDirectMusicPerformance;
    typedef int  IDirectMusicSegment;
    typedef int  MMCKINFO;
    typedef int  SOCKET;
    typedef int  WAVEFORMATEX;
    typedef int* HCURSOR;
    typedef int* HICON;
    typedef int* LPDIRECTSOUND;
    typedef int* LPDIRECTSOUNDBUFFER;
    typedef int* LPDIRECTSOUNDNOTIFY;

    #include <allegro.h>
    #include <stdio.h>
    #include <setjmp.h>
    #include <memory.h>
    #include <string.h>
    #ifndef _DEBUG
    extern "C" {
        #include "JpegLib.h"
    }
    #define debug_return 0
    #else
    #define debug_return return
    #define METHODDEF(x) x
    #define JMSG_LENGTH_MAX 1
    #define JDCT_FASTEST    1
    typedef int  j_func  (void*, void*);
    typedef void j_func2 (struct jpeg_decompress_struct*);
    struct jpeg_decompress_struct {
        unsigned dct_method,
                 do_block_smoothing,
                 do_fancy_upsampling,
                 output_height,
                 output_scanline,
                 output_width,
                 *setjmp_buffer;
        jpeg_decompress_struct *err;
        j_func   *format_message;
        j_func2  *error_exit;
    };
    typedef jpeg_decompress_struct* j_common_ptr;
    typedef jpeg_decompress_struct  jpeg_error_mgr;
    #endif

    typedef struct {
        DWORD    dwFileAttributes;
        FILETIME ftCreationTime;
        FILETIME ftLastAccessTime;
        FILETIME ftLastWriteTime;
        DWORD    nFileSizeHigh;
        DWORD    nFileSizeLow;
        DWORD    dwReserved0;
        DWORD    dwReserved1;
        CHAR     cFileName          [260];
        CHAR     cAlternateFileName  [16];
    } WIN32_FIND_DATA;

    class  DDraw   { public:
        void RestoreDisplayMode (void) { }
        void Release            (void) { }
    };
    class  CWinApp {};
    class  CDialog {};
    typedef DDraw* LPDIRECTDRAW;

    typedef BITMAP IDirectDrawSurface;
    typedef BITMAP SDL_Surface;
    typedef int DIR;
    typedef int SOCKADDR_IN;
    typedef int SOCKET;

enum {
    VK_ADD        = KEY_PLUS_PAD,
    VK_APOSTROPHE = KEY_BACKQUOTE,
    VK_BACK       = KEY_BACKSPACE,
    VK_BACKSLASH  = KEY_BACKSLASH,
    VK_BACKSLASH2 = KEY_BACKSLASH2,
    VK_CLEAR      = KEY_DEL,
    VK_COLON      = KEY_COLON,
    VK_COMMA      = KEY_COMMA,
    VK_CONTROL    = KEY_LCONTROL,
    VK_DELETE     = KEY_DEL_PAD,
    VK_DIVIDE     = KEY_SLASH_PAD,
    VK_DOWN       = KEY_DOWN,
    VK_END        = KEY_END,
    VK_EQUALSIGN  = KEY_EQUALS,
    VK_ESCAPE     = KEY_ESC,
    VK_F1         = KEY_F1,
    VK_F2         = KEY_F2,
    VK_F3         = KEY_F3,
    VK_F4         = KEY_F4,
    VK_F5         = KEY_F5,
    VK_F6         = KEY_F6,
    VK_F7         = KEY_F7,
    VK_F8         = KEY_F8,
    VK_F9         = KEY_F9,
    VK_F10        = KEY_F10,
    VK_F11        = KEY_F11,
    VK_F12        = KEY_F12,
    VK_HOME       = KEY_HOME,
    VK_INSERT     = KEY_INSERT,
    VK_LEFT       = KEY_LEFT,
    VK_LEFTBRACK  = KEY_OPENBRACE,
    VK_MENU       = KEY_ALT,
    VK_MINUS      = KEY_MINUS,
    VK_MULTIPLY   = KEY_ASTERISK,
    VK_NEXT       = KEY_PGDN,
    VK_NUMPAD0    = KEY_0_PAD,
    VK_NUMPAD1    = KEY_1_PAD,
    VK_NUMPAD2    = KEY_2_PAD,
    VK_NUMPAD3    = KEY_3_PAD,
    VK_NUMPAD4    = KEY_4_PAD,
    VK_NUMPAD5    = KEY_5_PAD,
    VK_NUMPAD6    = KEY_6_PAD,
    VK_NUMPAD7    = KEY_7_PAD,
    VK_NUMPAD8    = KEY_8_PAD,
    VK_NUMPAD9    = KEY_9_PAD,
    VK_PAUSE      = KEY_PAUSE,
    VK_PERIOD     = KEY_STOP,
    VK_PRIOR      = KEY_PGUP,
    VK_QUOTE      = KEY_QUOTE,
    VK_RCONTROL   = KEY_RCONTROL,
    VK_RETURN     = KEY_ENTER,
    VK_RIGHT      = KEY_RIGHT,
    VK_RIGHTBRACK = KEY_CLOSEBRACE,
    VK_SHIFT      = KEY_LSHIFT,
    VK_SLASH      = KEY_SLASH,
    VK_SPACE      = KEY_SPACE,
    VK_SUBTRACT   = KEY_MINUS_PAD,
    VK_TAB        = KEY_TAB,
    VK_UP         = KEY_UP,
    VK_0          = KEY_0,
    VK_A          = KEY_A,
    VK_LTR        = VK_A - 'A',
    VK_HACK       = KEY_UNKNOWN1
};

#endif

//{{AFX_INSERT_LOCATION}}
