#ifdef VIEWBASE_H
#error Double include
#endif
#define VIEWBASE_H
#define NO(x)

enum {
#ifdef _DEBUG
    PANEL_MAX = 7,
#else
    PANEL_MAX = 99,
#endif
};

enum ViewerState {
    VS_Hidden,
    VS_Disabled,
    VS_Visible,
    VS_MouseDis,
    VS_MouseOver,
    VS_Pressed
};

enum ViewerBacks {
    Bk_None,
    Bk_Black,
    Bk_Gray,
    Bk_GrayNE,
    Bk_Blue,
    Bk_Brown,
    Bk_White,
    Bk_Water,
    Bk_Select,
    Bk_Parch,
};

class CViewer {
    public:         CViewer      (void);
                    CViewer      (unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned);
    virtual void    Event        (unsigned, unsigned keys = 0);
    bool            MouseMove    (void);
    void            DrawMouse    (void);
    void            DrawBorder   (void);
    void            PullDown     (unsigned*, unsigned, unsigned, unsigned);
    void            Move         (int, int, bool rel = false);
    CViewer         *next;
    unsigned        state,
                    num,
                    tilexpos,
                    tileypos;

    protected:    
    virtual         ~CViewer     (void);
    void            Link         (CViewer*);
    void            Press        (void);
    void            DrawBack     (unsigned);
    unsigned        xpos,
                    ypos,
                    xsize,
                    ysize;
};

#define SubView(name, parms, extra)                             \
class name:                                                     \
    public          CViewer {                                   \
    public:         name         parms;                         \
    void            Event        (unsigned, unsigned keys = 0); \
    extra;                                                      \
};

SubView            (CBackView,   (int, int, unsigned, unsigned, unsigned), ;)
SubView            (CPanelView,  (unsigned type = 0xffff),
    void            Init         (unsigned);
    unsigned        RightClick   (void);
    void            MouseMove    (void); NO({)
    CPanelView      *link;               NO(})
)

class CPanelBase {
    public:         CPanelBase   (void);
    void            Previous     (void);
    bool            DoPullDown   (void);
    CPanelView      *toppanel,
                    *lastpanel   [PANEL_MAX];
    unsigned        mouseactive,
                    mousehelp,
                    panelcount,
                    pressdelay,
                    pd_x,
                    pd_y,
                    pd_dx,
                    pd_dy,
                    pd_base,
                    pd_len,
                    pd_flag,
                    *pd_var,
                    fade;
    char            buffer       [150];
    class CViewer   *mouseover,
                    *pressed;
};
